package org.bitbucket.bradleysmithllc.etlunit.feature.database;

import com.fasterxml.jackson.databind.JsonNode;
import org.bitbucket.bradleysmithllc.etlunit.feature.database.db.Database;
import org.bitbucket.bradleysmithllc.etlunit.feature.database.json.DatabaseDefinitionsProperty;
import org.bitbucket.bradleysmithllc.etlunit.feature.database.json.ImplementationProperties_;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;

import java.net.UnknownHostException;
import java.util.List;
import java.util.Map;

public interface DatabaseConnection {
	String getId();

	Database getDatabase();
	boolean hasDatabase();

	String getAdminUserName();
	String getAdminPassword();

	String getImplementationId();

	String getServerName();
	String getServerAddress() throws UnknownHostException;

	List<String> getSchemaScripts();

	DatabaseDefinitionsProperty getDatabaseConfiguration();
	JsonNode getRawDatabaseConfiguration();

	Map<String, String> getDatabaseProperties();

	void setDatabase(Database database);

	int getServerPort();
}