package org.bitbucket.bradleysmithllc.etlunit.feature.database;

public class FileRefImpl implements SQLAggregator.FileRef
{
	private final SQLAggregator.DDLRef beginRef;
	private final SQLAggregator.DDLRef endRef;

	private final int endAggregatedLineNumber;
	private final int beginAggregatedLineNumber;

	private final int endCleanLineNumber;
	private final int beginCleanLineNumber;

	private final String text;

	public FileRefImpl(SQLAggregator.DDLRef begin, SQLAggregator.DDLRef end, int baggNo, int eaggNo, int bcln, int ecln, String text)
	{
		beginRef = begin;
		endRef = end;
		this.text = text;
		beginAggregatedLineNumber = baggNo;
		endAggregatedLineNumber = eaggNo;
		beginCleanLineNumber = bcln;
		endCleanLineNumber = ecln;
	}

	public int getEndAggregatedLineNumber()
	{
		return endAggregatedLineNumber;
	}

	public int getEndCleanLineNumber()
	{
		return endCleanLineNumber;
	}

	public int getBeginCleanLineNumber()
	{
		return beginCleanLineNumber;
	}

	@Override
	public SQLAggregator.DDLRef getBeginRef()
	{
		return beginRef;
	}

	@Override
	public SQLAggregator.DDLRef getEndRef()
	{
		return endRef;
	}

	public int getBeginAggregatedLineNumber()
	{
		return beginAggregatedLineNumber;
	}

	public String getLine()
	{
		return text;
	}

	@Override
	public String describe()
	{
		return
				" beginDDLRef: " + beginRef.describe() +
				"', endDDLRef: " + endRef.describe() +
				", beginAggregateLine: " + getBeginAggregatedLineNumber() +
				", endAggregateLine: " + getEndAggregatedLineNumber() +
				", beginCleanLine: " + getBeginCleanLineNumber() +
				", endCleanLine: " + getEndCleanLineNumber() +
				", sql: '" + getLine() +
				"'";
	}
}